#include "fitting.hpp"

#include "point_set.hpp"
#include "polynomial.hpp"

#include <Eigen/Dense>

static void initialize_matrices(Eigen::MatrixXf& A,Eigen::VectorXf& b,int const N);


polynomial fitting(point_set const& points,int degree)
{
    int const N=degree+1;

    //make sure there is enough points
    if(points.size()<2*N)
        return polynomial();

    //initialize matrix
    Eigen::MatrixXf A;
    Eigen::VectorXf b;

    // Initialization
    initialize_matrices(A,b,N);

    // Fill matrices
    // *********************** //
    // TO DO :
    //
    //  Remplir matrices A et vecteur b
    //    avec les valeurs appropriees.
    //
    // *********************** //




    // Solve system matrix
    // *********************** //
    // TO DO :
    //
    //  Demander la resolution du systeme
    //    lineaire.
    //
    //  Calculer solution=A^{-1} x b
    //  Puis remplir un polynome avec
    //    les valeurs de la solution.
    //
    // *********************** //


    return polynomial(); //cette ligne doit etre enlevee

}



static void initialize_matrices(Eigen::MatrixXf& A,
                                Eigen::VectorXf& b,
                                int const N)
{
    //A has a size of NxN
    A.resize(N,N);
    //b is a vector of length N
    b.resize(N);

    //set all values to 0

    for(int k=0;k<N;++k)
        b(k)=0.0f;

    for(int kx=0;kx<N;++kx)
        for(int ky=0;ky<N;++ky)
            A(kx,ky)=0.0f;
}


