#include "fitting.hpp"

#include "point_set.hpp"
#include "polynomial.hpp"

#include <Eigen/Dense>

static void initialize_matrices(Eigen::MatrixXf& A,
                                Eigen::VectorXf& bx,
                                Eigen::VectorXf& by,
                                int const N);


polynomial fitting(point_set const& points,int degree)
{
    int const N=degree+1;

    //make sure there is enough points
    if(points.size()<N)
        return polynomial();

    //initialize matrix
    Eigen::MatrixXf A;
    Eigen::VectorXf bx,by;

    // Initialization
    initialize_matrices(A,bx,by,N);

    // Fill matrices
    // *********************** //
    // TO DO :
    //
    //  Remplir matrices A et vecteur bx,by
    //    avec les valeurs appropriees.
    //
    // *********************** //



    // Solve system matrix
    // *********************** //
    // TO DO :
    //
    //  Demander la resolution du systeme
    //    lineaire.
    //
    //  Calculer solution_x=A^{-1} bx
    //           solution_y=A^{-1} by
    //
    //  Puis remplir un polynome avec
    //    les valeurs de la solution.
    //
    // *********************** //


    return polynomial(); //ligne incorrecte
}

static void initialize_matrices(Eigen::MatrixXf& A,
                                Eigen::VectorXf& bx,
                                Eigen::VectorXf& by,
                                int const N)
{
    //A has a size of NxN
    A.resize(N,N);

    //bx,by are vector of length N
    bx.resize(N);
    by.resize(N);

    for(int k=0;k<N;++k)
    {
        bx(k)=0.0f;
        by(k)=0.0f;
    }

    for(int kx=0;kx<N;++kx)
        for(int ky=0;ky<N;++ky)
            A(kx,ky)=0.0f;
}




